var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\n\
      <meta name=\"product\" content=\"MBXPRO\" />\n\
      <meta name=\"release\" content=\"2019\" />\n\
      <meta name=\"book\" content=\"Developer\" />\n\
      <meta name=\"created\" content=\"2018-11-26\" />\n\
      <meta name=\"topicid\" content=\"GUID-3425EEE1-0AC1-4268-BAB6-D48DE249099F\" />\n\
      <meta name=\"topic-type\" content=\"concept\" />\n\
      <title>Sampling Texture Values</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3425EEE1-0AC1-4268-BAB6-D48DE249099F\"></a><div class=\"head\">\n\
            <h1>Sampling Texture Values</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-7232\"></a> The following are the steps involved in accessing a specific texture value at a point\n\
            on the surface: \n\
         </p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-7231\"></a><ol type=\"1\" start=\"1\">\n\
            <li> Calculate the texture coordinate associated for the surface point. This can be done\n\
               by calculating a linear combination of the texture coordinates at the corners of the\n\
               face based on the information you have about where the point is inside the face. \n\
            </li>\n\
            <li> Decide which texture are you interested in, by examining the list of textures in\n\
               the corresponding <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Material\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Material</a></span> instance by calling the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Material::TextureCount()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_material.html#accbcf4c2216b60dc1cf4688d5bcdb763&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Material::TextureCount()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Material::Texture()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_material.html#acf06ea2f86b7c311f4ef4e5dc3fa622f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Material::Texture()</a></span> functions. You can get the name of a texture by calling its implementation <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Node::Name()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_node.html#a1c226db9ed67ed302e6c32e768fbee67&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Node::Name()</a></span> function. This list can change depending on the material implementation. The default\n\
               Mudbox material has a fixed list, but materials created from custom CgFX files can\n\
               have very different texture lists. \n\
            </li>\n\
            <li> Since Mudbox supports layers for each texture, you next need to choose the layer\n\
               you are interested in. To do this, cast the pointer obtained in step 2 to a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Node</a></span>. Then cast to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"LayerContainer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_layer_container.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">LayerContainer</a></span> using <span class=\"code\" translate=\"no\">dynamic_cast</span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">LayerContainer* TexturePoolToLayerContainer(TexturePool* tp) {  Node* <a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_g_lee_8h.html#a830e6eb5d1b77f7226a78592ba9d2613&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a> = tp;  return dynamic_cast&lt;LayerContainer*&gt;(<a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_g_lee_8h.html#a830e6eb5d1b77f7226a78592ba9d2613&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a>);}</pre></div> \n\
            </li>\n\
            <li> Once you have a pointer to a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"LayerContainer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_layer_container.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">LayerContainer</a></span> instance, you can check the list of layers and their names. \n\
            </li>\n\
            <li> Based on your interpolated texture coordinate, you have to select the proper tile\n\
               in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"TexturePool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_texture_pool.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">TexturePool</a></span> by calling the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"TexturePool::Tile()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_texture_pool.html#ae5cad5e5b6a2a77251a9734896101e17&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">TexturePool::Tile()</a></span> function. (If the UV space of an object goes beyond the range 0-1, Mudbox uses multiple\n\
               tiles to represent each layer of a texture.) Pass in a bounding box representing the\n\
               tile you are interested in. For example, if the desired texture coordinate is 1.3,\n\
               3.4, then you would pass in a bounding box between ( 1, 3, 0 ) and ( 2, 4, 0 ). In\n\
               texture space, the third coordinate is always 0. Once you get the tile, you would\n\
               sample the texture pixel (texel) at 0.3, 0.4 within that tile. \n\
            </li>\n\
            <li> Once you got the texture, copy it to an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Image\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_image.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Image</a></span> object by calling the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Texture::CopyTo()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_texture.html#a3ac6e2879ced24a2a40932f40577babe&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Texture::CopyTo()</a></span> function. You can easily access the color of the needed pixel by calling the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Image::ColorAt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_image.html#aa2004242d7be0c7970ef92ab00576086&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Image::ColorAt()</a></span> function. Note that copying a texture to an image is a slow process, so if you want\n\
               to sample multiple surface points, it is preferable to copy the textures only once,\n\
               and cache it. \n\
            </li>\n\
         </ol>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br /><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\" /></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br /></div>\n\
   </div></body>\n\
</html>";