var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\n\
      <meta name=\"product\" content=\"MBXPRO\" />\n\
      <meta name=\"release\" content=\"2019\" />\n\
      <meta name=\"book\" content=\"Developer\" />\n\
      <meta name=\"created\" content=\"2018-11-26\" />\n\
      <meta name=\"topicid\" content=\"GUID-A03466A3-413E-4D55-A137-35234539F982\" />\n\
      <meta name=\"description\" content=\"This topic describes the basic information related to writing plug-ins.\" />\n\
      <meta name=\"topic-type\" content=\"concept\" />\n\
      <title>Writing Plug-ins</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A03466A3-413E-4D55-A137-35234539F982\"></a><div class=\"head\">\n\
            <h1>Writing Plug-ins</h1>\n\
         </div>\n\
         <p class=\"blurb\"> This topic describes the basic information related to writing plug-ins. </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-7182\"></a> \n\
            <h2><a name=\"GUID-4C6B7049-1906-4CE5-9A14-5708F39ABCBA\"></a>Plug-in Basics\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-7181\"></a> Most Mudbox plug-ins are represented in memory using the class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Plugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_q_web_plugin_factory_1_1_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Plugin</a></span>. However, when you write a custom plug-in, you must use the macro <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MB_PLUGIN\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/mudbox_8h.html#afa2df46a730e8fc8bceb9410c0ff6838&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MB_PLUGIN</a></span> to create an instance of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Plugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_q_web_plugin_factory_1_1_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Plugin</a></span> class. \n\
            </p> \n\
            <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-7180\"></a> In order to expose a plug-in\'s functionality to Mudbox, you must hook into the Mudbox\n\
               RTTI system (see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-BEFC2483-F8FB-41B2-801E-A8C5A7EE567F.htm\">Run-Time Type Information (RTTI)</a></span>). This is done using the macros <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"DECLARE_CLASS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a431009564592a24e5f46f5df421131a1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">DECLARE_CLASS</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"IMPLEMENT_CLASS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a1d51ad935ab5d26fe95dff62601b602c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">IMPLEMENT_CLASS</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-717F\"></a> \n\
            <h2><a name=\"GUID-46E666F4-1C5D-4190-A72E-FFED6FE745E3\"></a>Plug-in Base Classes\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-717E\"></a> All plug-ins derive either directly or indirectly from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Node</a></span> class. The following classes are used as base classes for specialized kinds of plug-ins:\n\
               \n\
            </p> <a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-717D\"></a><ul>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"ScreenSpacePicker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_screen_space_picker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ScreenSpacePicker</a></span> - Base class of mesh point selection plug-ins. \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Picker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_picker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Picker</a></span> - Base class of plug-ins used for finding points on a mesh corresponding to one another.\n\
                  \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Importer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_importer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Importer</a></span> - Base class of mesh importer plug-ins. \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Exporter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_exporter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Exporter</a></span> - Base class of mesh exporter plug-ins. \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"SurfaceSmoother\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_surface_smoother.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">SurfaceSmoother</a></span> - Base class of plug-ins that provide information about the limit surface of a mesh.\n\
                  \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"TangentGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_tangent_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">TangentGenerator</a></span> - Base class of plug-ins that customize the definition of tangent space. \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"BrushOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_brush_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">BrushOperation</a></span> - Base class of custom brush plug-ins. \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MeshGrid\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_mesh_grid.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MeshGrid</a></span> - Base class of plug-ins that control the algorithm for dividing meshes into grids.\n\
                  \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MeshRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classmudbox_1_1_mesh_renderer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MeshRenderer</a></span> - Base class of plug-ins that transform a mesh into the OpenGL pipeline. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"see-also\">\n\
            <h4>See Also</h4>\n\
            <div class=\"related-links\">\n\
               <ul>\n\
                  <li> <span class=\"char_link\"><a href=\"#!/url=./files/GUID-73D9C185-7038-4715-8179-51F2779E8AB6.htm\">Kinds of Plug-ins</a></span> \n\
                  </li>\n\
               </ul>\n\
            </div>\n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-BEFC2483-F8FB-41B2-801E-A8C5A7EE567F.htm\">Run-Time Type Information (RTTI)</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-1DD5EC9C-9DDF-421F-8853-9EFB8749D0A3.htm\">Instantiating Classes and Plug-ins</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-8AA0BA36-AEC4-4E5F-AD42-EC056E117156.htm\">Mesh Importer and Exporter Plug-ins</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-D99AC5B5-59F0-45DB-9D76-EDFB995169A5.htm\">Serializing Plug-in Data</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br /><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\" /></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br /></div>\n\
   </div></body>\n\
</html>";